- block:
  - name: "delete manifest {{ item.file }}"
    command: "kubectl delete -n {{ item.namespace }} -f -"
    args:
      stdin: "{{ lookup('template', 'templates/'+item.file) }}"
    register: kubectl_apply
    changed_when: 'kubectl_apply.rc == 0'
    when: item.file is defined | default(False) | bool and item.namespace is defined

  - name: "delete manifest {{ item.file }}"
    command: "kubectl delete -f -"
    args:
      stdin: "{{ lookup('template', 'templates/'+item.file) }}"
    register: kubectl_apply
    changed_when: 'kubectl_apply.rc == 0'
    when: item.file is defined | default(False) | bool and item.namespace is not defined

  - name: "delete manifest {{ item.url }}"
    command: "kubectl delete -n {{ item.namespace }} -f {{ item.url }}"
    register: kubectl_apply
    changed_when: 'kubectl_apply.rc == 0'
    when: item.url is defined | default(False) | bool and item.namespace is defined

  - name: "delete manifest {{ item.url }}"
    command: "kubectl delete -f {{ item.url }}"
    register: kubectl_apply
    changed_when: 'kubectl_apply.rc == 0'
    when: item.url is defined | default(False) | bool and item.namespace is not defined

  when: item.state is defined and item.state == 'absent'
  rescue:
    - debug:
        msg: "stderr: {{ kubectl_apply.stderr | default('') }}"
      when: kubectl_apply.failed

    - debug:
        msg: "{{ lookup('template', 'templates/'+item.file).split('\n') }}"
      when: kubectl_apply.failed and item.file is defined

    - name: "upload manifest {{ item.file }}"
      template:
        src: "templates/{{ item.file }}"
        dest: "/tmp/{{ item.file | basename }}"
      when: item.file is defined and item.keepfile is defined
